/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System.Collections.Generic;using UnityEngine;namespace PluginIdea.DecalSystem{[RequireComponent(typeof(MeshRenderer))]    [RequireComponent(typeof(MeshFilter))]    public class DecalComp : MonoBehaviour{private MeshFilter meshFilter = null;private MeshRenderer meshRenderer = null;private Mesh currMesh = null;private MeshDecal ower;private List<Vector3> vertices = new List<Vector3>();private List<Vector3> normals = new List<Vector3>();private List<int> indices = new List<int>();private List<Vector2> texcoords = new List<Vector2>();private MeshRenderer[] mrs;private GameObject meshHolderObject;private MeshFilter meshFilterHolder;private MeshRenderer meshRenderHolder;private GameObject wireMeshHolderObject;private MeshFilter wireMeshFilterHolder;private MeshRenderer wireMeshRenderHolder;public Transform WireMeshHolderTrans{get{return this.wireMeshHolderObject.transform;}}public Transform MeshHolderTrans{get{return this.meshHolderObject.transform;}}private void Awake(){meshFilter = GetComponent<MeshFilter>();meshRenderer = GetComponent<MeshRenderer>();meshHolderObject = new GameObject("MeshHolder");meshHolderObject.transform.SetParent(transform);meshHolderObject.transform.localPosition = Vector3.zero;meshHolderObject.transform.localScale = Vector3.one;meshHolderObject.transform.rotation = transform.rotation;meshFilterHolder = Utils.GetSafeComponent<MeshFilter>(meshHolderObject);meshRenderHolder = Utils.GetSafeComponent<MeshRenderer>(meshHolderObject);meshRenderHolder.shadowCastingMode = UnityEngine.Rendering.ShadowCastingMode.Off;wireMeshHolderObject = new GameObject("WireMeshHolder");wireMeshFilterHolder = Utils.GetSafeComponent<MeshFilter>(wireMeshHolderObject);wireMeshRenderHolder = Utils.GetSafeComponent<MeshRenderer>(wireMeshHolderObject);wireMeshHolderObject.SetActive(false);SyncWireMesh();}private void SyncWireMesh(){wireMeshHolderObject.transform.SetParent(meshHolderObject.transform.parent);wireMeshHolderObject.transform.localPosition = meshHolderObject.transform.localPosition;wireMeshHolderObject.transform.localScale = meshHolderObject.transform.localScale;wireMeshHolderObject.transform.rotation = meshHolderObject.transform.rotation;wireMeshFilterHolder.mesh = meshFilterHolder.mesh;}public void Init(MeshDecal ower){this.ower = ower;}public void GetTargetObejcts(){List<MeshRenderer> selfRenders = ower.GetComponentInParent<Atom>().GetComponentsInChildren<MeshRenderer>().ToList();mrs = FindObjectsOfType<MeshRenderer>();if (mrs.Length > 0){foreach (var r in mrs){if (selfRenders.Contains(r)) continue;if (meshRenderer.bounds.Intersects(r.bounds)){GenerateDecalMesh(r);}}GenerateUnityMesh();}}private Vector3[] meshVertices;private int[] meshTriangles;private List<Vector3> vectorList = new List<Vector3>();private void GenerateDecalMesh(MeshRenderer target){var mesh = target.GetComponent<MeshFilter>().sharedMesh;meshVertices = mesh.vertices;meshTriangles = mesh.triangles;var targetToDecalMatrix = transform.worldToLocalMatrix * target.transform.localToWorldMatrix;for (int i = 0;i < meshTriangles.Length;i = i + 3){var index1 = meshTriangles[i];var index2 = meshTriangles[i + 1];var index3 = meshTriangles[i + 2];var vertex1 = meshVertices[index1];var vertex2 = meshVertices[index2];var vertex3 = meshVertices[index3];vertex1 = targetToDecalMatrix.MultiplyPoint(vertex1);vertex2 = targetToDecalMatrix.MultiplyPoint(vertex2);vertex3 = targetToDecalMatrix.MultiplyPoint(vertex3);var dir1 = vertex1 - vertex2;var dir2 = vertex1 - vertex3;var normalDir = Vector3.Cross(dir1, dir2).normalized;vectorList.Clear();vectorList.Add(vertex1);vectorList.Add(vertex2);vectorList.Add(vertex3);CollisionChecker.CheckCollision(vectorList);if (vectorList.Count > 0)                    AddPolygon(vectorList.ToArray(), normalDir);}}private void AddPolygon(Vector3[] poly, Vector3 normal){int ind1 = AddVertex(poly[0], normal);for (int i = 1;i < poly.Length - 1;i++){int ind2 = AddVertex(poly[i], normal);int ind3 = AddVertex(poly[i + 1], normal);indices.Add(ind1);indices.Add(ind2);indices.Add(ind3);}}private int AddVertex(Vector3 vertex, Vector3 normal){int index = FindVertex(vertex);if (index == -1){vertices.Add(vertex);normals.Add(normal);float u = Mathf.Lerp(0.0f, 1.0f, vertex.x + 0.5f);float v = Mathf.Lerp(0.0f, 1.0f, vertex.y + 0.5f);texcoords.Add(new Vector2(u, v));return vertices.Count - 1;}else{normals[index] = (normals[index] + normal).normalized;return index;}}private int FindVertex(Vector3 vertex){for (int i = 0;i < vertices.Count;i++){if (Vector3.Distance(vertices[i], vertex) < 0.0001f){return i;}}return -1;}private void HandleZFighting(float distance){for (int i = 0;i < vertices.Count;i++){vertices[i] += normals[i] * distance;}}private void GenerateUnityMesh(){currMesh = new Mesh();currMesh.Clear(true);currMesh.vertices = vertices.ToArray();currMesh.normals = normals.ToArray();currMesh.triangles = indices.ToArray();currMesh.uv = texcoords.ToArray();currMesh.RecalculateTangents();currMesh.RecalculateNormals();currMesh.RecalculateBounds();vertices.Clear();normals.Clear();indices.Clear();texcoords.Clear();meshFilterHolder.sharedMesh = currMesh;SyncWireMesh();}}public class CollisionChecker{private static List<Plane> planList = new List<Plane>();static CollisionChecker(){planList.Add(new Plane(Vector3.forward, 0.5f));planList.Add(new Plane(Vector3.back, 0.5f));planList.Add(new Plane(Vector3.up, 0.5f));planList.Add(new Plane(Vector3.down, 0.5f));planList.Add(new Plane(Vector3.left, 0.5f));planList.Add(new Plane(Vector3.right, 0.5f));}private static void CheckCollision(Plane plane, List<Vector3> vectorList){var newList = new List<Vector3>();for (var current = 0;current < vectorList.Count;current++){var next = (current + 1) % vectorList.Count;var v1 = vectorList[current];var v2 = vectorList[next];var currentPointIn = plane.GetSide(v1);if (currentPointIn == true)                    newList.Add(v1);if (plane.GetSide(v2) != currentPointIn){float distance;var ray = new Ray(v1, v2 - v1);plane.Raycast(ray, out distance);var newPoint = ray.GetPoint(distance);newList.Add(newPoint);}}vectorList.Clear();vectorList.AddRange(newList);}public static void CheckCollision(List<Vector3> vectorList){foreach (var curPlane in planList){CheckCollision(curPlane, vectorList);}}}}