/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.Video;using UnityEngine.UI;using System.Linq;using System;using System.Collections.Generic;using MVR.FileManagementSecure;namespace PluginIdea.DecalSystem{public class LastPara{public bool isActivePlaybackSpeed;}public class VideoPlayerModule{private const string DefaultVideoFolder = "Custom/Assets/Videos";public Action<Texture> onVideoTextureSettedCallback;private JSONStorableBool isLoop;private JSONStorableFloat audioVolume;private JSONStorableFloat playSpeed;private JSONStorableBool isActivePlaySpeed;private JSONStorableFloat playProgress;private JSONStorableUrl videoUrl;private JSONStorableBool isPlayOnStart;private JSONStorableAction beginRenderAction;private JSONStorableAction endRenderAction;private JSONStorableFloat targetRenderFPS;private JSONStorableAction playAction;private JSONStorableAction pauseAction;private JSONStorableAction stopAction;private JSONStorableAction nextVideoAction;private JSONStorableAction prevVideoAction;private JSONStorableFloat playTime;private VideoPlayer videoPlayer;private AudioSource audioSource;private List<string> videoUrls = new List<string>();private int currentVideoIndex;private LastPara lastPara = new LastPara();public VideoPlayerModule(DynamicDecal ower){this.ower = ower;}public void Init(){Utils.CreateSpacer(ower, 20, true);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.VideoPlaySubtitle), 40, true);videoUrl = Utils.SetupVideoChooser(ower, Location.GetStr(Location.ChooseVideoFile), DefaultVideoFolder, true, LoadVideoClip, ower.acs);playAction = Utils.SetupAction(this.ower, "Play", Play);stopAction = Utils.SetupAction(this.ower, "Stop", Stop);pauseAction = Utils.SetupAction(this.ower, "Pause", Pause);nextVideoAction = Utils.SetupAction(this.ower, "Next Video", PlayNext);prevVideoAction = Utils.SetupAction(this.ower, "Prev Video", PlayPrev);beginRenderAction = Utils.SetupAction(this.ower, "Begin Render", BeginRender);endRenderAction = Utils.SetupAction(this.ower, "End Render", EndRender);isPlayOnStart = Utils.CreateToggle(ower, Location.GetStr(Location.PlayOnStart), true, true, ower.acs);isLoop = Utils.CreateToggle(ower, Location.GetStr(Location.IsLoop), true, true, ower.acs);isLoop.setCallbackFunction = (val =>{videoPlayer.isLooping = val;});audioVolume = Utils.CreateSliderFloat(ower, Location.GetStr(Location.AudioVolume), 1f, 0f, 1f, true, ower.acs);audioVolume.setCallbackFunction = (val) =>{audioSource.volume = val;};isActivePlaySpeed = Utils.CreateToggle(ower, Location.GetStr(Location.IsActivePlaybackSpeed), false, true, ower.acs);isActivePlaySpeed.setCallbackFunction = (val) =>{videoPlayer.playbackSpeed = val ? playSpeed.val : 1;};playSpeed = Utils.CreateSliderFloat(ower, Location.GetStr(Location.PlaySpeed), 1f, 0.1f, 5f, true, ower.acs);playSpeed.setCallbackFunction = (val) =>{if (isActivePlaySpeed.val) videoPlayer.playbackSpeed = val;};playTime = Utils.CreateSliderFloat(ower, Location.GetStr(Location.PlayTime), 0f, 0, 5, true, ower.acs);playTime.setCallbackFunction = SetTime;Utils.CreateSpacer(ower, 20, true);Utils.CreateButton(ower, Location.GetStr(Location.Play), Play, true, ower.acs);Utils.CreateButton(ower, Location.GetStr(Location.Pause), Pause, true, ower.acs);Utils.CreateButton(ower, Location.GetStr(Location.Stop), Stop, true, ower.acs);Utils.CreateButton(ower, Location.GetStr(Location.PlayNext), PlayNext, true, ower.acs);Utils.CreateButton(ower, Location.GetStr(Location.PlayPrev), PlayPrev, true, ower.acs);Utils.CreateSpacer(ower, 20, true);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.RenderSubtitle), 40, true);Utils.CreateButton(ower, Location.GetStr(Location.RenderPrepare), () =>{SetTime(0);}, true, ower.acs);targetRenderFPS = Utils.CreateSliderInt(ower, Location.GetStr(Location.RenderTargetFPS), 60, 10, 120, true, ower.acs);AddVideoComponents();}private string filenameSelect;private void SetVideoFiles(string url){filenameSelect = FileManagerSecure.GetFileName(url);string dir = FileManagerSecure.GetDirectoryName(url);List<string> files = new List<string>();Utils.GetAllSubFiles(dir, ref files);if (files.Count > 0){videoUrls = files.Where(u => Utils.IsVideoSupport(u)).ToList();}}public void DelayInit(){if (!string.IsNullOrEmpty(videoUrl.val)){videoUrl.Reload();}}public void Reset(){if (videoPlayer != null){videoPlayer.Stop();}videoUrl.val = string.Empty;}public void AddVideoComponents(){videoPlayer = Utils.GetSafeComponent<VideoPlayer>(ower.gameObject);audioSource = Utils.GetSafeComponent<AudioSource>(ower.gameObject);videoPlayer.playOnAwake = false;audioSource.playOnAwake = false;videoPlayer.source = VideoSource.Url;videoPlayer.renderMode = VideoRenderMode.APIOnly;videoPlayer.audioOutputMode = VideoAudioOutputMode.AudioSource;videoPlayer.controlledAudioTrackCount = 1;videoPlayer.EnableAudioTrack(0, true);videoPlayer.SetTargetAudioSource(0, audioSource);videoPlayer.isLooping = isLoop.val;videoPlayer.prepareCompleted += OnVideoPlayerPrepared;audioSource.volume = audioVolume.val;}private string pathSelect;private void LoadVideoClip(string path){if (string.IsNullOrEmpty(path)) return;SetVideoFiles(path);if (videoUrls.Count > 0){currentVideoIndex = 0;pathSelect = videoUrls.FirstOrDefault(x => x.EndsWith(filenameSelect));currentVideoIndex = videoUrls.IndexOf(pathSelect);if (currentVideoIndex < 0) currentVideoIndex = 0;VideoDataPrepare();if (isPlayOnStart.val)                    Play();}}public void PlayNext(){if (videoUrls.Count > 0){currentVideoIndex++;if (currentVideoIndex > videoUrls.Count - 1)                    currentVideoIndex = 0;VideoDataPrepare();Play();}}public void PlayPrev(){if (videoUrls.Count > 0){currentVideoIndex--;if (currentVideoIndex < 0)                    currentVideoIndex = videoUrls.Count - 1;VideoDataPrepare();Play();}}private void VideoDataPrepare(){videoPlayer.Stop();string firstUrl = videoUrls[currentVideoIndex];if (!firstUrl.StartsWith("http:")){string realpath = Utils.GetGameRootDir() + "/" + firstUrl;videoPlayer.url = realpath;videoPlayer.Play();videoPlayer.Pause();}}private int skipAmount;private void OnVideoPlayerPrepared(VideoPlayer source){Debug.Log(source.url + " is prepared");source.texture.wrapMode = TextureWrapMode.Repeat;source.texture.filterMode = FilterMode.Trilinear;playTime.max = videoPlayer.frameCount / videoPlayer.frameRate;skipAmount = Mathf.RoundToInt((targetRenderFPS.val / videoPlayer.frameRate));Debug.Log(videoPlayer.frameRate);if (onVideoTextureSettedCallback != null) onVideoTextureSettedCallback(source.texture);}private void SetProgress(float progress){if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameCount * progress);videoPlayer.frame = targetFrame;}}private void SetTime(float time){if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameRate * time);targetFrame = (long)Mathf.Clamp(targetFrame, 0, videoPlayer.frameCount);videoPlayer.frame = targetFrame;videoPlayer.Pause();}}private void EndRender(){isOnRendering = false;isActivePlaySpeed.val = lastPara.isActivePlaybackSpeed;}private bool isOnRendering;private void BeginRender(){if (!ower.acs){SuperController.LogError(Location.GetStr(Location.NotBuyTip));return;}if (videoPlayer != null && videoPlayer.isPrepared){endRenderAction.actionCallback();if (!isOnRendering){lastPara.isActivePlaybackSpeed = isActivePlaySpeed.val;isActivePlaySpeed.val = false;skipAmount = Mathf.RoundToInt((targetRenderFPS.val / videoPlayer.frameRate));skipCounter = 0;currentRenderIndex = 0;ower.StartCoroutine(VideoRender());}}else{SuperController.LogError("You haven't selected a video yet. Please select a video file before rendering.");return;}}private int skipCounter;private long currentRenderIndex;private DynamicDecal ower;private IEnumerator VideoRender(){isOnRendering = true;while (isOnRendering){yield return new WaitForEndOfFrame();skipCounter++;if (skipCounter >= skipAmount){skipCounter = 0;videoPlayer.frame = currentRenderIndex;currentRenderIndex++;if ((ulong)currentRenderIndex >= videoPlayer.frameCount){EndRender();}}}}public void Play(){if (ower.IsOnImagePlayType){SuperController.LogError("The current playback type is -Image-. Switch to -Video-, and then play the video.");return;}if (videoPlayer != null) videoPlayer.Play();}public void Stop(){if (videoPlayer != null) videoPlayer.Stop();}public void Pause(){if (videoPlayer != null) videoPlayer.Pause();}public void UnInit(){videoUrl.val = string.Empty;GameObject.Destroy(videoPlayer);GameObject.Destroy(audioSource);}}}